<template>
  <div >
    <p>
      Введите данные для восстановления доступа в личный кабинет.
    </p>
    <div @keyup.enter="restoringPassword">
      <div>
        <label for="f-email">Ваш адрес <b>электронной почты / логин / номер телефона</b></label>
        <input v-model="dataForRestore.login"
               v-validate="validated"
               type="text"
               autocomplete="off"
               name="email"
               id="f-email"
               v-mask="mobile"
               @input="checkMobile"
               @blur="checkData"
               :class="getValidateClass('email')"
        />
        <validate-message v-show="vErrors.has('email')">
          {{ vErrors.first('email') }}
        </validate-message>
      </div>
      <div>
        <label for="f-fio">Фамилия, на которую зарегистрирован аккаунт</label>
        <input v-model="dataForRestore.lastName"
               v-validate="'required|cyrillic|min:2|max:50'"
               type="text"
               name="lastname"
               id="f-fio"
               autocomplete="off"
               :class="getValidateClass('lastname')"
               @keyup.enter="restoringPassword"
        />
        <validate-message v-show="vErrors.has('lastname')">
          {{ vErrors.first('lastname') }}
        </validate-message>
      </div>
    </div>
    <div class="center">
      <button @click="restoringPassword"
        :disabled="$interface.buttonLoading"
              class="button red"
        :class="{button_loading: $interface.buttonLoading}">
        Восстановить пароль
      </button>
    </div>

    <div class="center">
      <div class="message message-info">
        <div class="message-icon">
          <SVGIcon xlink="info-icon" :fill="$theme.colors.blue"></SVGIcon>
        </div>
        <div class="message-text">Что-то не получается? Обратитесь <span class="link" @click="toggleChat">в службу поддержки</span>.</div>
      </div>
    </div>
  </div>
</template>

<script>
    import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
    import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
    import { REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
    import ValidateMessage from '@/components/Validators/ValidateMessage'
    import ToggleChat from '@/mixins/Chat/ToggleChat';
    import SVGIcon from '@/components/SVGIcon';

export default {
      name: 'RestoreForm',
      data () {
        return {
          dataForRestore: {
            lastName: '',
            login: ''
          },
          errors: '',
          validated: 'required',
          mobile: ''
        }
      },
      mixins: [
        ErrorHandleMixin,
        GetValidateClass,
        ValidateMessage,
		  ToggleChat,
      ],
    components: {
		SVGIcon
    },
      methods: {
        checkMobile () {
          let login = this.dataForRestore.login
          if (login !== '') {
            if (login[0] === '1' || login[0] === '2') {
              this.validated = 'required|min:9'
              this.mobile = '##########'
              return false
            }
            if (login[0] === '9') {
              this.validated = 'required|standartMobilePhone'
              this.mobile = '8(###)###-####'
              return false
            }
            if (login[0] === '8' && login[1] === '9') {
              this.validated = 'required|standartMobilePhone'
              this.mobile = '8(###)###-####'
              return false
            }
            if (login[0] === '7' && login[1] === '9') {
              this.validated = 'required|standartMobilePhone'
              this.mobile = '8(###)###-##-##'
              return false
            }
            if (login[0] === '+' && login[1] === '7') {
              this.validated = 'required|standartMobilePhone'
              this.mobile = '8(###)###-####'
              return false
            }
            if (/[А-Яа-я]/.test(login)) {
              this.validated = 'required|latin'
              return false
            }
          } else {
            this.validated = 'required'
            this.mobile = ''
          }
        },
        checkData () {
          let login = this.dataForRestore.login
          if (login !== '') {
            if (login[0] === '1' || login[0] === '2') {
              this.validated = 'required|min:9|max:10'
              this.mobile = '##########'
              return false
            }
            if (/[А-Яа-я]/.test(login)) {
              this.validated = 'required|latin'
              return false
            }
            if (/@/.test(login)) {
              this.validated = 'required|email|min:4|max:50'
              return false
            }
            if ((login[0] !== '8' && login[1] !== '(') && !/@/.test(login)) {
              this.validated = 'required|nonStandart'
              return false
            }
            if (login[0] === '9') {
              this.validated = 'required|standartMobilePhone'
              this.mobile = '8(9##)###-####'
              return false
            }
            if (login[0] === '8' && login[1] === '9') {
              this.validated = 'required|standartMobilePhone'
              this.mobile = '8(9##)-###-####'
              return false
            }
            if (login[0] === '7' && login[1] === '9') {
              this.validated = 'required|standartMobilePhone'
              this.mobile = '8(9##)-###-####'
              return false
            }
            if (login[0] === '+' && login[1] === '7') {
              this.validated = 'required|standartMobilePhone'
              this.mobile = '8(9##)###-####'
              return false
            }
          } else {
            this.validated = 'required'
            this.mobile = ''
          }
        },
        restoringPassword () {
          this.$validator.validateAll()
            .then(err => {
              if (err !== false) {
                this.$emit('restore', {...this.dataForRestore})
              }
            })
        }
      },
      mounted () {
        this.$validator.localize(REQUIRED_FIELD)
        this.$validator.localize(MIN_LENGHT)
        this.$validator.localize(MAX_LENGHT)
        if (this.$store.getters.getReinstatement.status) {
            this.dataForRestore.login = this.$store.getters.getReinstatement.phone
        }
      },
      watch: {
        dataForRestore: {
          handler: function (newVal) {
            if (newVal.lastName && newVal.login) {
              this.$emit('input', newVal)
            } else {
              this.$emit('input', null)
            }
          },
          deep: true
        }
      }
    }
</script>

<style scoped lang="scss">
  .message-text {
    text-align: left !important;
    margin-right: 0 !important;
    line-height: 1 !important;
    letter-spacing: normal !important;
  }
</style>
